summaryrefslogtreecommitdiff
path: root/tests/tail-2/assert-2
diff options
context:
space:
mode:
Diffstat (limited to 'tests/tail-2/assert-2')
-rwxr-xr-xtests/tail-2/assert-266
1 files changed, 66 insertions, 0 deletions
diff --git a/tests/tail-2/assert-2 b/tests/tail-2/assert-2
new file mode 100755
index 0000000..f535758
--- /dev/null
+++ b/tests/tail-2/assert-2
@@ -0,0 +1,66 @@
+#!/bin/sh
+# This variant of `assert' would get a UMR reliably in 2.0.9.
+# Due to a race condition in the test, the `assert' script would get
+# the UMR on Solaris only some of the time, and not at all on Linux/GNU.
+
+# Copyright (C) 2000, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+# Not "expensive" per se, but sleeping for so long is annoying.
+. $srcdir/../very-expensive
+
+tmp=tail-as2.$$
+pwd=`pwd`
+trap 'cd "$pwd" && rm -rf $tmp' 0 1 2 3 15
+
+test_failure=0
+mkdir $tmp || test_failure=1
+cd $tmp || test_failure=1
+
+if test $test_failure = 1; then
+ echo 'failure in testing framework'
+ exit 1
+fi
+
+ok='ok ok ok'
+
+touch a
+tail --follow=name a foo > err 2>&1 &
+tail_pid=$!
+# Arrange for the tail process to die after 12 seconds.
+(sleep 12; kill $tail_pid) &
+echo $ok > f
+echo sleeping for 7 seconds...
+sleep 7
+mv f foo
+
+# echo waiting....
+wait
+
+case "`cat err`" in
+ *$ok) fail=0;;
+ *) fail=1;;
+esac
+
+test $fail = 1 && cat err
+
+exit $fail